using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using VLInteger;
using VLIntAnwendungen;

namespace Test
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();          
        }

        public void TestVLI(string z1, string z2, Boolean large)
        {
            VLInt zahl1 = new VLInt(z1);
            VLInt zahl2 = new VLInt(z2);
            VLInt zahl3 = new VLInt("-" + z1);
            VLInt zahl4 = new VLInt("-" + z2);
            VLInt Ergebnis = new VLInt();

            richTextBox1.AppendText("---------------------------------------------------------------------\n");
            Ergebnis.Add(zahl1, zahl2);
            richTextBox1.AppendText(zahl1.AsFString + " + " + zahl2.AsFString + " = " + Ergebnis.AsFString + "\n");

            if (large)
            {
                Ergebnis.Add(zahl1, zahl4);
                richTextBox1.AppendText(zahl1.AsFString + " + " + zahl4.AsFString + " = " + Ergebnis.AsFString + "\n");

                Ergebnis.Add(zahl3, zahl2);
                richTextBox1.AppendText(zahl3.AsFString + " + " + zahl2.AsFString + " = " + Ergebnis.AsFString + "\n");

                Ergebnis.Add(zahl3, zahl4);
                richTextBox1.AppendText(zahl3.AsFString + " + " + zahl4.AsFString + " = " + Ergebnis.AsFString + "\n");
            }

            richTextBox1.AppendText("" + "\n");

            Ergebnis.Sub(zahl1, zahl2);
            richTextBox1.AppendText(zahl1.AsFString + " - " + zahl2.AsFString + " = " + Ergebnis.AsFString + "\n");

            if (large)
            {
                Ergebnis.Sub(zahl1, zahl4);
                richTextBox1.AppendText(zahl1.AsFString + " - " + zahl4.AsFString + " = " + Ergebnis.AsFString + "\n");

                Ergebnis.Sub(zahl3, zahl2);
                richTextBox1.AppendText(zahl3.AsFString + " - " + zahl2.AsFString + " = " + Ergebnis.AsFString + "\n");

                Ergebnis.Sub(zahl3, zahl4);
                richTextBox1.AppendText(zahl3.AsFString + " - " + zahl4.AsFString + " = " + Ergebnis.AsFString + "\n");
            }

            richTextBox1.AppendText("" + "\n");         

            Ergebnis.Multiply(zahl1, zahl2);
            richTextBox1.AppendText(zahl1.AsFString + " x " + zahl2.AsFString + " = " + Ergebnis.AsFString + "\n");

            if (large)
            {
                Ergebnis.Multiply(zahl1, zahl4);
                richTextBox1.AppendText(zahl1.AsFString + " x " + zahl4.AsFString + " = " + Ergebnis.AsFString + "\n");

                Ergebnis.Multiply(zahl3, zahl2);
                richTextBox1.AppendText(zahl3.AsFString + " x " + zahl2.AsFString + " = " + Ergebnis.AsFString + "\n");

                Ergebnis.Multiply(zahl3, zahl4);
                richTextBox1.AppendText(zahl3.AsFString + " x " + zahl4.AsFString + " = " + Ergebnis.AsFString + "\n");
            }
    
            richTextBox1.AppendText("" + "\n");

            Ergebnis.Division(zahl1, zahl2);
            richTextBox1.AppendText(zahl1.AsFString + " / " + zahl2.AsFString + " = " + Ergebnis.AsFString + "\n");

            if (large)
            {
                Ergebnis.Division(zahl1, zahl4);
                richTextBox1.AppendText(zahl1.AsFString + " / " + zahl4.AsFString + " = " + Ergebnis.AsFString + "\n");

                Ergebnis.Division(zahl3, zahl2);
                richTextBox1.AppendText(zahl3.AsFString + " / " + zahl2.AsFString + " = " + Ergebnis.AsFString + "\n");

                Ergebnis.Division(zahl3, zahl4);
                richTextBox1.AppendText(zahl3.AsFString + " / " + zahl4.AsFString + " = " + Ergebnis.AsFString + "\n");
            }

            richTextBox1.AppendText("" + "\n");

            Ergebnis.Modulo(zahl1, zahl2);
            richTextBox1.AppendText(zahl1.AsFString + " / " + zahl2.AsFString + " = " + Ergebnis.AsFString + "\n");


            richTextBox1.AppendText("" + "\n");

            if (zahl1 == zahl2)
            {
                richTextBox1.AppendText(zahl1.AsFString + " == " + zahl2.AsFString + "\n");
            }
            else
            {
                richTextBox1.AppendText(zahl1.AsFString + " != " + zahl2.AsFString + "\n");
            }
            
            if (zahl1 <= zahl2)
            {
                richTextBox1.AppendText(zahl1.AsFString + " <= " + zahl2.AsFString + "\n");
            }
            else
            {
                richTextBox1.AppendText(zahl1.AsFString + " >= " + zahl2.AsFString + "\n");
            }
            if (zahl1.Gerade())
            {
                richTextBox1.AppendText(zahl1.AsFString + " GERADE \n");
            }
            else
            {
                richTextBox1.AppendText(zahl1.AsFString + " UNGERADE \n");
            }

            zahl1.Dispose();
            zahl2.Dispose();
            zahl3.Dispose();
            zahl4.Dispose();
            Ergebnis.Dispose();
        }

        public void TestVLISpecial(string z1, string z2)
        {
            VLInt zahl1 = new VLInt(z1);
            VLInt zahl2 = new VLInt(z2);
            VLInt x = new VLInt();
            VLInt Ergebnis;
            VLIntApps Anwendung = new VLIntApps();

            //erzeugt neues Objekt
            Ergebnis = Anwendung.ggT(zahl1, zahl2);
            richTextBox1.AppendText("ggt("+zahl1.AsFString +", "+zahl2.AsFString+") = "+Ergebnis.AsFString+"\n");
            //erzeugt neues Objekt
            Ergebnis.Dispose();
            Ergebnis = Anwendung.kgV(zahl1, zahl2);
            richTextBox1.AppendText("kgV(" + zahl1.AsFString + ", " + zahl2.AsFString + ") = " + Ergebnis.AsFString + "\n");
            //erzeugt neues Objekt
            Ergebnis.Dispose();
            x.AsString = "5";
            Ergebnis = Anwendung.b_m_mod_n(zahl1, zahl2, x);
            richTextBox1.AppendText("b_m_mod_n("+zahl1.AsFString +", "+zahl2.AsFString+", "+x.AsFString+") = "+Ergebnis.AsFString + "\n");
            //erzeugt neues Objekt
            Ergebnis.Dispose();
            /*
            x.AsString = "5";
            Ergebnis = Anwendung.x_pow_y_mod_m(zahl1, zahl2, x);
            richTextBox1.AppendText("b_m_mod_n(" + zahl1.AsFString + ", " + zahl2.AsFString + ", " + x.AsFString + ") = " + Ergebnis.AsFString + "\n");
            //erzeugt neues Objekt
            Ergebnis.Dispose();
             * */
            x.AsString = "5";
            Ergebnis = Anwendung.Egypt_a_b_mod_c(zahl1, zahl2, x);
            richTextBox1.AppendText("Egypt_a_b_mod_c(" + zahl1.AsFString + ", " + zahl2.AsFString + ", " + x.AsFString + ") = " + Ergebnis.AsFString + "\n");

            zahl1.Dispose();
            zahl2.Dispose();
            Ergebnis.Dispose();
        }
               

        private void button1_Click(object sender, EventArgs e)
        {
            Boolean large = false;
            DateTime start = DateTime.Now;
                        
            richTextBox1.Clear();
            TestVLISpecial("10000005000999999243", "5000123123");
            
            TestVLI("10000005000999999243", "5000123123", large);
            TestVLI("0", "5000123123", large);
            // TestVLI("12000999999999", "12000000001");
            //  TestVLI("12000000001", "12000000001");
            //TestVLI("13", "3");
            // TestVLI("10000000000000000012", "10000000000000000012");
            // TestVLI("123000000123", "12000000245");

            
            DateTime stop = DateTime.Now;

            VLInt anz = new VLInt();
            richTextBox1.AppendText("\n-- " + Convert.ToString((stop.Ticks - start.Ticks) / 10000) + " ms / " +
                Convert.ToString((stop.Ticks - start.Ticks) / 10) + " us \n");
            richTextBox1.AppendText("-- Anzahl Zahlen " + Convert.ToString(anz.VLIIntCount));            
            anz.Dispose();
        }

        private void Form1_Shown(object sender, EventArgs e)
        {
            //button1_Click(sender, e);
        }

        private void button3_Click(object sender, EventArgs e)
        {
            VLInt zahl1 = new VLInt("126346514354126346413");
            VLInt zahl2 = new VLInt("286858162654265463518458524");
            VLInt x = new VLInt("24535663546");
            VLInt Ergebnis = new VLInt();
            VLIntApps Anwendung = new VLIntApps();
            string str2 = "";
            int anz = 10;
            int i;
            string[] buffer;

            DateTime start;
            DateTime stop;
            richTextBox1.Clear();
//--------------------------------------------------------------------------------------------
            str2 = "Berechnung b_m_mod_n luft " + Convert.ToString(anz) + " Mal ";
            richTextBox1.AppendText(str2);
            richTextBox1.Update();     
            
            //erzeugt neues Objekt
            start = DateTime.Now;
            for (i = 0; i < anz; i++)
            {
                Ergebnis.Dispose();
                Ergebnis = Anwendung.b_m_mod_n(zahl1, zahl2, x);  //3 244 341 727
                str2 += ".";

                buffer = richTextBox1.Lines;
                buffer[buffer.Length - 1] = str2;
                richTextBox1.Lines = buffer;
                richTextBox1.Update();
            }
            richTextBox1.AppendText("\nb_m_mod_n(" + zahl1.AsFString + ", " + zahl2.AsFString + ", " + x.AsFString + ") = " + "\n"+Ergebnis.AsFString + "\n");
            stop = DateTime.Now;
            richTextBox1.AppendText("\n-- " + Convert.ToString((stop.Ticks - start.Ticks) / 10000) + " ms\n\n");
//--------------------------------------------------------------------------------------------            
            start = DateTime.Now;
            str2 = "Berechnung Egypt_a_b_mod_c luft " + Convert.ToString(anz) + " Mal ";
            richTextBox1.AppendText(str2);
            richTextBox1.Update();

            //erzeugt neues Objekt
            for (i = 0; i < 1; i++)
            {
                Ergebnis.Dispose();
                Ergebnis = Anwendung.Egypt_a_b_mod_c(zahl1, zahl2, x);
                str2 += ".";
                buffer = richTextBox1.Lines;
                buffer[buffer.Length - 1] = str2;
                richTextBox1.Lines = buffer;
                richTextBox1.Update();
            }
            richTextBox1.AppendText("\nEgypt_a_b_mod_c(" + zahl1.AsFString + ", " + zahl2.AsFString + ", " + x.AsFString + ") = " + "\n" + Ergebnis.AsFString + "\n");
            stop = DateTime.Now;
            richTextBox1.AppendText("\n-- " + Convert.ToString((stop.Ticks - start.Ticks) / 10000) + " ms\n\n");
//--------------------------------------------------------------------------------------------
            start = DateTime.Now;
            str2 = "Berechnung Pow luft ";
            richTextBox1.AppendText(str2);
            richTextBox1.Update();

            zahl1.AsString = "126345";
            zahl2.AsString = "2048";
            
            Ergebnis.Dispose();
            Ergebnis = Anwendung.Pow(zahl1, zahl2);
            
            richTextBox1.AppendText("\nPow(" + zahl1.AsFString + " ^ " + zahl2.AsFString + ") = " + "\n" + Ergebnis.AsString + "\n");
            stop = DateTime.Now;
            richTextBox1.AppendText("\n-- " + Convert.ToString((stop.Ticks - start.Ticks) / 10000) + " ms\n\n");


            Ergebnis.Dispose();
            Ergebnis = Anwendung.Pow_Bin(zahl1, zahl2);

            richTextBox1.AppendText("\nPow(" + zahl1.AsFString + " ^ " + zahl2.AsFString + ") = " + "\n" + Ergebnis.AsString + "\n");
            stop = DateTime.Now;
            richTextBox1.AppendText("\n-- " + Convert.ToString((stop.Ticks - start.Ticks) / 10000) + " ms\n\n");
            
            zahl1.Dispose();
            zahl2.Dispose();
            Ergebnis.Dispose();
        }

        private void button4_Click(object sender, EventArgs e)
        {
            VLInt zahl1 = new VLInt("9999999999937658237658268562837568263458624735698743698569827659869836597862439569243659789999999");  //252 000 000 534 000 000 280 OK
            VLInt zahl2 = new VLInt("654645369999999999999");
            VLInt N = new VLInt();
            N.Multiply(zahl1, zahl2);
            
                        
            VLIntRabinMiller rabin = new VLIntRabinMiller();

            N.AsString = "9999999999937658237658268562837568263458624735698743698569827659869836597862439569243659789999999";
            N.AsString = "861";
            if (rabin.isPrime(N))
            {
                richTextBox1.AppendText(N.AsString +" ist prim\n");
            }
            else
            {
                richTextBox1.AppendText(N.AsString +" ist NICHT prim\n");
            }

            N.AsString = "73";
            if (rabin.isPrime(N))
            {
                richTextBox1.AppendText(N.AsString + " ist prim\n");
            }
            else
            {
                richTextBox1.AppendText(N.AsString + " ist NICHT prim\n");
            }

            N.AsString = "10";
            if (rabin.isPrime(N))
            {
                richTextBox1.AppendText(N.AsString + " ist prim\n");
            }
            else
            {
                richTextBox1.AppendText(N.AsString + " ist NICHT prim\n");
            }

            rabin.Dispose();
            zahl1.Dispose();
            zahl2.Dispose();
            N.Dispose();
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            VLInt Count = new VLInt();
            toolStripStatusLabel1.Text = Convert.ToString(Count.VLIIntCount-1);
            Count.Dispose();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            VLInt N = new VLInt();

            VLIntRabinMiller rabin = new VLIntRabinMiller();
            richTextBox1.Clear();
            //starte ab der Zahl 11
            for (int i = 51; i <= 1000; i++)
            {
                N.AsString = Convert.ToString(i);
                if (rabin.isPrime(N))
                {
                    richTextBox1.AppendText(N.AsString + "\n");
                }
                else
                {
                    toolStripStatusLabel1.Text = Convert.ToString(i);
                }
                Application.DoEvents();
            }
            N.Dispose();
            rabin.Dispose();
        }

    }
}